#!/usr/bin/perl -w
#
#statview
#
#Perl/Tk-frontend zur organisierten darstellung der dolphinsim football stats
#
#(c) xor (Michael Mhlhaus) 09/2004
#
#Dies ist GPL Software.
#

package main;

#use strict;
use Tk;
require Tk::ROText;
require Tk::NoteBook;
require Tk::LabEntry;
#no strict refs;



my $version="statview 0.0.9 BETA";

my ($message,$mw,$nb,$p1,$p2,$p3,$frame1,$statrot,@mystats, $header, $frame21, $frame4, $frame5, $frame6, $frame7);

my $abouthelp="$version\n
Coded by xor (Michael Mhlhaus)
xor\@bilderverbot.com
(c) 2004
This is free software, covered by the GNU General Public License.\nPlease read the file 'COPYING' distributed with this program.\n";

my (@offarr,@defarr, @sdefarr, @soffarr,$byravg,$bypavg,$bypeny,$bypen,$byrty,$byfm,$bysck,$byin,$byrtd,$byry,$byr,$byptd,$bypy,$bypc,$bypa,$ph2,$inputavg,$findteam,$order,@comparr,$compstat, $comprot, $pctline, $pctstat, @pctarr,@spctarr, $passpct, $comp, $too, $tod, $toline, @toarr, $torot);

my $offselect=0;

$mw = MainWindow->new;
$mw->title("$version");
$mw->minsize(700,700);  # zweiter Wert ist hoehe
$mw->geometry ('+1+1');

my $statusmess = $mw->Label(-textvariable => \$message) ->pack(-side =>
 'bottom', -fill => 'x', -ipady =>5);

 $nb=$mw->NoteBook()->pack(-expand =>1, -fill => 'both');
 $p1= $nb->add('page1', -label => 'ViewStats');
 $p2= $nb->add('page2', -label => 'DerivStats');
 $p3= $nb->add('page3', -label => 'About');



#///////////
#p1
#
#////////////


$frame1=$p1->Frame;

my $mt=$frame1->LabEntry(-label => "Find: ",
				 -labelPack     => [qw/-side left -anchor w/],
				 -relief        => 'sunken',
				 -width         => 11,						
                 -textvariable => \$findteam,
                   )->pack;
    &bind_message ($mt, "Teamnamen fur Suche eingeben"); 
my $ft=$frame1->Button(-text=>"FindTeam",-command => \&findteam)->pack(); 

$frame1-> Label(-text => " ", -anchor => 'w', -font => 'Courier 1') -> pack();
$frame1->Button(-text=>" Save ",-command => \&saving)->pack(-side=>'top', -expand=>1);
$frame1->Button(-text=>" Exit ",-command => \&exit)->pack(-side=>'top', -expand=>1);
$frame1-> Label(-text => "", -font => 'Courier 1', -anchor => 'w') -> pack();
my $b1=$frame1->Button(-text=>"Offense",-command => \&loadoff)->pack(-side=>'left');
$frame1->Button(-text=>"Defense",-command => \&loaddef)->pack(-side=>'left');


my $frame2=$p1->Frame;
$frame2-> Label(-text => "\n\nSort by: ", -anchor => 'e') -> pack();

$frame2->Button(-text=>"PA  ",-font=>'Courier 9',-command => \&sortpa)->pack();
$frame2->Button(-text=>"PC  ",-font=>'Courier 9',-command => \&sortpc)->pack();
$frame2->Button(-text=>"PY  ",-font=>'Courier 9',-command => \&sortpy)->pack();
$frame2->Button(-text=>"PTD ",-font=>'Courier 9',-command => \&sortptd)->pack();
$frame2->Button(-text=>"R   ",-font=>'Courier 9',-command => \&sortr)->pack();
$frame2->Button(-text=>"RY  ",-font=>'Courier 9',-command => \&sortry)->pack();
$frame2->Button(-text=>"RTD ",-font=>'Courier 9',-command => \&sortrtd)->pack();
$frame2->Button(-text=>"In  ",-font=>'Courier 9',-command => \&sortin)->pack();
$frame2->Button(-text=>"Sck ",-font=>'Courier 9',-command => \&sortsck)->pack();
$frame2->Button(-text=>"Fm  ",-font=>'Courier 9',-command => \&sortfm)->pack();
$frame2->Button(-text=>"RtY ",-font=>'Courier 9',-command => \&sortrty)->pack();
$frame2->Button(-text=>"Pen ",-font=>'Courier 9',-command => \&sortpen)->pack();
$frame2->Button(-text=>"PenY",-font=>'Courier 9',-command => \&sortpeny)->pack();
$frame2->Button(-text=>"PAvg",-font=>'Courier 9',-command => \&sortpavg)->pack();
$frame2->Button(-text=>"RAvg",-font=>'Courier 9',-command => \&sortravg)->pack();


my $frame3=$p1->Frame;
my $headlab= $frame3-> Label(-text => "         PA  PC  PY   PTD  R  RY  RTD In Sck Fm  RtY  Pen  PenY  PAvg  RAvg", -font=>'Courier 9', -anchor => 'w', -justify =>'left') -> pack();
#$statrot = $frame3->Scrolled ('ROText',-scrollbars => 'ose', width=> 81, height=> 32)->pack(-side=>'bottom', -after =>$headlab);
$statrot = $frame3->Scrolled('Listbox', -scrollbars =>'ose', -width => 81, -height=> 28, -font => "Courier 9")->pack(-side=>'bottom', -after =>$headlab);



#///////////
#p2
#
#////////////
$frame4=$p2->Frame;

$frame4->Label(-text => "Completion Rates: ", -anchor => 'e')->pack();
$compstat = $frame4->Scrolled('Listbox', -scrollbars =>'ose', -width =>14, -height=> 32, -font => "Courier 9")->pack();


$frame5=$p2->Frame;
$frame5->Label(-text => "Anteil RushingPlays: ", -anchor => 'e')->pack();
$pctstat = $frame5->Scrolled('Listbox', -scrollbars =>'ose', -width =>14, -height=> 32, -font => "Courier 9")->pack();

$frame6=$p2->Frame;
$frame6->Label(-text => "Turnovers: ", -anchor => 'e')->pack();
$torot = $frame6->Scrolled('ROText', -scrollbars =>'ose', -width =>16, -height=> 32, -font => "Courier 9")->pack();









#///////////
#p3
#
#////////////
my $b5;

$frame7=$p3->Frame;

$b5=$frame7->Button(-text=>"About",-command => \&abouthelp)->pack(-side=>'left', -expand=>1);







#/////////////////
#
#/////////////////

$frame1->pack(-side => 'top', -anchor=> 'nw');
$frame2->pack(-side => 'left', -anchor=> 'nw');
$frame3->pack(-side => 'left', -anchor=> 'nw');
$frame4->pack(-side => 'left', -anchor=> 'nw');
$frame5->pack(-side => 'left', -anchor=> 'nw');
$frame6->pack(-side => 'left', -anchor=> 'nw');
$frame7->pack(-side => 'left', -anchor=> 'nw');
loading();


MainLoop;

#///////////////////////////
#subs
#//////////////////////////


#//////////////////////////////////
sub loading
{
	my (@myarr, $deathmess,$nuline, $temp,@tempo);
my $filename="stats.txt";
my $offense=0; my $defense=0;
my $index=0; my $index2=0;


open(MYFILE, $filename) or $deathmess=$!; 
@myarr=<MYFILE>;
close MYFILE;


foreach my $line  (@myarr)
{
 chomp $line;
 $line =~ s/^\s+//;
 

if ($line =~ m/Offense/)
{
	$offense=1;
}
elsif ($line =~ m/^Name/)
 {
	 $header=$line;
# print "$header\n";
 }
#///////////
#start offense
#/////////////////
 elsif (($line =~ m/^\w+ /)  && ($offense==1) && ($line !~ m/Defense/)) #offense teams
 {
#  print "$line\n";

 $line  =~ s/\s<\S+>//;


my  @fields =  split(" ", $line);


  # teamnamen mit mehreren woertern
    if ($fields[1] =~ m/\D+/)
        {
    # print "2parts\n";
    # print "fields1=$fields[1]\n";

                $temp = $fields[0] . $fields[1];
        shift @fields; shift @fields;
        $tempo[0] = $temp;
        push(@tempo, @fields);
        @fields=@tempo;
        undef @tempo;

        }
 #nochmal fuer 3 parts
 if ($fields[1] =~ m/\D+/)
        {
   #                print "3parts\n";
   #     print "fields1=$fields[1]\n";
                $temp = $fields[0] . $fields[1];
        shift @fields; shift @fields;
        $tempo[0] = $temp;
        push @tempo, @fields;
        @fields=@tempo;
                undef @tempo;
        }


if (length ($fields[0]) > 10)  #kuerzen von ueberlangen teamnamen
  {
 $fields[0] = substr $fields[0], 0, 10; 
  }


 my $i = 10 - length ($fields[0]);
    if ($i>0)
	{
     $fields[0] = $fields[0] .  " " x $i; 
    }

   if ($fields[1] < 100)
   {
	   $fields[1]="0" . $fields[1];
   }
   if ($fields[1] < 10)
   {
	   $fields[1]="0" . $fields[1];
   }
   if ($fields[2] < 100)
   {
	   $fields[2]="0" . $fields[2];
   }
   if ($fields[2] < 10)
   {
	   $fields[2]="0" . $fields[2]; #pc 
   }
   if ($fields[3] < 1000)
   {
	   $fields[3]="0" . $fields[3]; #py
   }
   if ($fields[3] < 100)
   {
	   $fields[3]="0" . $fields[3];
   }
   if ($fields[3] < 10)
   {
	   $fields[3]="0" . $fields[3];
   }
   if ($fields[4] < 10)
   {
	   $fields[4]="0" . $fields[4];   #ptd
   }
   if ($fields[5] < 100)
   {
	   $fields[5]="0" . $fields[5];
   }
   if ($fields[5] < 10)
   {
	   $fields[5]="0" . $fields[5];  #r
   }
   if ($fields[6] < 1000)
   {
	   $fields[6]="0" . $fields[6];
   }
   if ($fields[6] < 100)
   {
	   $fields[6]="0" . $fields[6];
   }
   if ($fields[6] < 10)
   {
	   $fields[6]="0" . $fields[6]; #ry
   }
   if ($fields[7] < 10)
   {
	   $fields[7]="0" . $fields[7];   #rtd
   }
   if ($fields[8] < 10)
   {
	   $fields[8]="0" . $fields[8];   #in
   }
   if ($fields[9] < 10)
   {
	   $fields[9]="0" . $fields[9];   #sck
   }
   if ($fields[10] < 10)
   {
	   $fields[10]="0" . $fields[10];   #fm
   }
   if ($fields[11] < 1000)
   {
	   $fields[11]="0" . $fields[11];
   }
   if ($fields[11] < 100)
   {
	   $fields[11]="0" . $fields[11];
   }
   if ($fields[11] < 10)
   {
	   $fields[11]="0" . $fields[11]; #rty
   }
   if ($fields[12] < 100)
   {
	   $fields[12]="0" . $fields[12];
   }
   if ($fields[12] < 10)
   {
	   $fields[12]="0" . $fields[12];   #pen
   }
   if ($fields[13] < 100)
   {
	   $fields[13]="0" . $fields[13]; #peny
   }
   if ($fields[13] < 10)
   {
	   $fields[13]="0" . $fields[13]; #peny
   }
   if ($fields[14] < 10)
   {
	   $fields[14]="0" . $fields[14]; #pavg
   }
   if ($fields[15] < 10)
   {
	   $fields[15]="0" . $fields[15]; #ravg
   }



 $nuline ="";

   foreach my $adjline (@fields)
   {
	   $nuline = $nuline . " " .  $adjline;
   }    
   $line=$nuline;   # . "\n";
   undef $nuline;



   $line =~ s/(\d{4}) /$1  /g;
   $line =~ s/(\d{2} \d{2}) /$1  /g;
   $line =~ s/(\d{2,3} \d{1,2}\.\d) /  $1 /g;  
   $line =~ s/(\d{1,2}\.\d{1,2}) / $1  /g;  



if ($line =~ m/League/)
{
	 $inputavg=$line;
}


if ($line !~ m/League/)
 { 

$comp= sprintf("%.2f", $fields[2]/$fields[1]);
$comp = ($comp * 100) . "\%";
$passpct= sprintf("%.2f", $fields[5]/ ($fields[5]+$fields[1]));
$passpct = ($passpct * 100) . "\%";
$too=  sprintf("%.2f", -($fields[8] + $fields[10])); 

my $compline = $fields[0] . " " . $comp;
 $pctline = $fields[0] . " " . $passpct;
 $toline=   $fields[0] . " " . $too;


$comparr[$index] = $compline;
$pctarr[$index] = $pctline;

#array of arrays; damit spaeter turnovers der defense inegriert werden koennen

$toarr[$index]= [ split ' ', $toline ];

$offarr[$index] = $line;
# $offarr[$index] = $offarr[$index] . "\n";
 $index++; 
 }




}



#////////////////
elsif ($line =~ m/Defense/)
{
	$offense=0; $defense=1;
}
#elsif (($line =~ m/^\w+ <\w+/)  && ($defense==1) && ($line !~ m/Offense/)) #defense teams

elsif (($line =~ m/^\w+ /)  && ($defense==1) && ($line !~ m/Offense/)) #defense teams
 {

 $line  =~ s/\s*<\S+>//;


my  @fields =  split(" ", $line);

#  print "fields1=$fields[1]\n";
#  print "line=$line\n";


  # teamnamen mit mehreren woertern
    if ($fields[1] =~ m/\D+/)
        {
 #               print "2parts\n";
 #               print "fields1=$fields[1]\n";

                $temp = $fields[0] . $fields[1];
        shift @fields; shift @fields;
        $tempo[0] = $temp;
        push(@tempo, @fields);
        @fields=@tempo;
        undef @tempo;

        }
 if ($fields[1] =~ m/\D+/)
        {
 #               print "3parts\n";
 #       print "fields1=$fields[1]\n";
                $temp = $fields[0] . $fields[1];
        shift @fields; shift @fields;
        $tempo[0] = $temp;
        push @tempo, @fields;
        @fields=@tempo;
                undef @tempo;
        }


if (length ($fields[0]) > 10)  #kuerzen von ueberlangen teamnamen
  {
 $fields[0] = substr $fields[0], 0, 10; 
  }


 my $i = 10 - length ($fields[0]);
    if ($i>0)
	{
     $fields[0] = $fields[0] .  " " x $i; 
    }

   if ($fields[1] < 100)
   {
	   $fields[1]="0" . $fields[1];
   }
   if ($fields[1] < 10)
   {
	   $fields[1]="0" . $fields[1];
   }
   if ($fields[2] < 100)
   {
	   $fields[2]="0" . $fields[2];
   }
   if ($fields[2] < 10)
   {
	   $fields[2]="0" . $fields[2]; #pc 
   }
   if ($fields[3] < 1000)
   {
	   $fields[3]="0" . $fields[3]; #py
   }
   if ($fields[3] < 100)
   {
	   $fields[3]="0" . $fields[3];
   }
   if ($fields[3] < 10)
   {
	   $fields[3]="0" . $fields[3];
   }
   if ($fields[4] < 10)
   {
	   $fields[4]="0" . $fields[4];   #ptd
   }
   if ($fields[5] < 100)
   {
	   $fields[5]="0" . $fields[5];
   }
   if ($fields[5] < 10)
   {
	   $fields[5]="0" . $fields[5];  #r
   }
   if ($fields[6] < 1000)
   {
	   $fields[6]="0" . $fields[6];
   }
   if ($fields[6] < 100)
   {
	   $fields[6]="0" . $fields[6];
   }
   if ($fields[6] < 10)
   {
	   $fields[6]="0" . $fields[6]; #ry
   }
   if ($fields[7] < 10)
   {
	   $fields[7]="0" . $fields[7];   #rtd
   }
   if ($fields[8] < 10)
   {
	   $fields[8]="0" . $fields[8];   #in
   }
   if ($fields[9] < 10)
   {
	   $fields[9]="0" . $fields[9];   #sck
   }
   if ($fields[10] < 10)
   {
	   $fields[10]="0" . $fields[10];   #fm
   }
   if ($fields[11] < 1000)
   {
	   $fields[11]="0" . $fields[11];
   }
   if ($fields[11] < 100)
   {
	   $fields[11]="0" . $fields[11];
   }
   if ($fields[11] < 10)
   {
	   $fields[11]="0" . $fields[11]; #rty
   }
   if ($fields[12] < 100)
   {
	   $fields[12]="0" . $fields[12];
   }
   if ($fields[12] < 10)
   {
	   $fields[12]="0" . $fields[12];   #pen
   }
   if ($fields[13] < 100)
   {
	   $fields[13]="0" . $fields[13]; #peny
   }
   if ($fields[13] < 10)
   {
	   $fields[13]="0" . $fields[13]; #peny
   }
   if ($fields[14] < 10)
   {
	   $fields[14]="0" . $fields[14]; #pavg
   }
   if ($fields[15] < 10)
   {
	   $fields[15]="0" . $fields[15]; #ravg
   }



 $nuline ="";

   foreach my $adjline (@fields)
   {
	   $nuline = $nuline . " " .  $adjline;
   }    
   $line=$nuline;   # . "\n";
    undef $nuline;


   $line =~ s/(\d{4}) /$1  /g;
   $line =~ s/(\d{2} \d{2}) /$1  /g;
   $line =~ s/(\d{2,3} \d{1,2}\.\d) /  $1 /g;  
   $line =~ s/(\d{1,2}\.\d{1,2}) / $1  /g;  

#//////////////////////

if ($line !~ m/League/) 
{
#/////////////
# turnovers defesne in toarr integrieren

$tod=sprintf("%.2f", $fields[8] + $fields[10]); 

 $toarr[$index2]->[1]=$toarr[$index2]->[1]+$tod;


 print "$toarr[$index2]->[0]  ";
 print "$toarr[$index2]->[1]\n";

#print @toarr;


#///////////////////


 $defarr[$index2] = $line;
 $index2++; 
}
#///////////////end defense
 }




}


#$statrot->insert('1.0', $header1);
foreach my $line (@offarr)
{
$statrot->insert('end', $line);
}
$offselect=1;
$message="Offense selected.";

#completion array sortieren
my @scomparr = sort { (split ' ', $b )[-1] cmp  (split ' ', $a)[-1] } @comparr;

my   @spctarr = sort { (split ' ', $b )[-1] cmp  (split ' ', $a)[-1] } @pctarr;

#my   @stoarr = sort {  $b->[-1]  <=>  $a->[-1] } @toarr;

my   @stoarr = sort { (sprintf("%3i", $b->[-1]))  <=>  (sprintf("%3i", $a->[-1])) } @toarr;




foreach my $line (@scomparr)
{
$compstat->insert('end', $line);
}

foreach my $line (@spctarr)
{
$pctstat->insert('end', $line);
}


foreach my $line (@stoarr)
{

#alignment
$line->[0]= sprintf("%-10s", $line->[0]);
$line->[1]= sprintf("%+3d", $line->[1]);

#while (length($line->[0]) < 10)
#{
#     $line->[0] = $line->[0] . " ";
#}


#das funktioniert nur unter linux
#$torot->insert('end', $line);

#das funzt auch unter win
$torot->insert('end', $line->[0] . "   " .  $line->[1] . "\n");


#print("$line->[0]  $line->[1]\n");
}





}




#///////////
#end main
#/////////

#/////
#sub  loadoff
#/////

sub loadoff
{
$statrot->delete(0, 'end');
foreach my $line (@offarr)
{
$statrot->insert('end', $line);
}
$offselect=1;
$message="Offense selected.";
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}

#/////
#sub  loaddef
#/////

sub loaddef
{
$statrot->delete(0, 'end');
foreach my $line (@defarr)
{
$statrot->insert('end', $line);
}
$offselect=0;
$message="Defense selected.";
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}

#//////////////
#end sub loaddef
#//////////////

#/////
#sub  sortravg  rushing average
#/////

sub sortravg
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byravg=1;
$order="by RAVG";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-1] cmp  (split ' ', $a)[-1] } @defarr;
foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Rushing Average";
}

else
{
@soffarr = sort { (split ' ', $b )[-1] cmp  (split ' ', $a)[-1] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Rushing Average";
}

$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  RAVG");

}
#//////////////
#end sub sortravg
#//////////////

#/////
#sub  sortpavg
#/////
sub sortpavg
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bypavg=1;
$order="by PAVG";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-2] cmp  (split ' ', $a)[-2] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Passing Average";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-2] cmp  (split ' ', $a)[-2] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Passing Average";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  PAVG  ravg");
}

#//////////////
#end sub sortpavg
#//////////////


#/////
#sub  sortpeny
#/////
sub sortpeny
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bypeny=1;
$order="by PENY";
$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-3] cmp  (split ' ', $a)[-3] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Penalty Yards.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-3] cmp  (split ' ', $a)[-3] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Penalty Yards";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  PENY  pavg  ravg");
}

#//////////////
#end sub sortpeny
#//////////////

#/////
#sub  sortpen
#/////
sub sortpen
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bypen=1;
$order="by PEN";
$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-4] cmp  (split ' ', $a)[-4] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Penalties.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-4] cmp  (split ' ', $a)[-4] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Penalties";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  rty  PEN  peny  pavg  ravg");
}

#//////////////
#end sub sortpen
#//////////////


#/////
#sub  sortrty
#/////
sub sortrty
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byrty=1;
$order="by RTY";
$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-5] cmp  (split ' ', $a)[-5] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Return Yards.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-5] cmp  (split ' ', $a)[-5] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Return Yards";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck fm  RTY  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortrty
#//////////////


#/////
#sub  sortfm
#/////
sub sortfm
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byfm=1;
$order="by FM";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-6] cmp  (split ' ', $a)[-6] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Fumbles.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-6] cmp  (split ' ', $a)[-6] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Fumbles";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in sck FM  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortfm
#//////////////

#/////
#sub  sortsck
#/////
sub sortsck
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bysck=1;
$order="by sck";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-7] cmp  (split ' ', $a)[-7] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Sacks.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-7] cmp  (split ' ', $a)[-7] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Sacks";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd in SCK fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortsck
#//////////////

#/////
#sub  sortin
#/////
sub sortin
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byin=1;
$order="by IN";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-8] cmp  (split ' ', $a)[-8] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Interceptionss.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-8] cmp  (split ' ', $a)[-8] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Interceptions";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  rtd IN sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortin
#//////////////

#/////
#sub  sortrtd
#/////
sub sortrtd
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byrtd=1;
$order="by RTD";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-9] cmp  (split ' ', $a)[-9] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Rushing Touchdowns.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-9] cmp  (split ' ', $a)[-9] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Rushing Touchdowns.";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   ry  RTD in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortrtd
#//////////////

#/////
#sub  sortry
#/////
sub sortry
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byry=1;
$order="by RY";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-10] cmp  (split ' ', $a)[-10] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Rushing Yards.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-10] cmp  (split ' ', $a)[-10] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Rushing Yards";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  r   RY  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortry
#//////////////


#/////
#sub  sortr
#/////
sub sortr
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byr=1;
$order="by R";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-11] cmp  (split ' ', $a)[-11] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Rushing Attempts.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-11] cmp  (split ' ', $a)[-11] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Rushing Attempts";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   ptd  R   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortr
#//////////////


#/////
#sub  sortptd
#/////
sub sortptd
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$byptd=1;
$order="by PTD";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-12] cmp  (split ' ', $a)[-12] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Passing Touchdowns.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-12] cmp  (split ' ', $a)[-12] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Passing Touchdowns.";
}
$headlab->configure(-text =>"\n\n       pa  pc  py   PTD  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortptd
#//////////////



#/////
#sub  sortpy
#/////
sub sortpy
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bypy=1;
$order="by PY";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-13] cmp  (split ' ', $a)[-13] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Passing Yards.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-13] cmp  (split ' ', $a)[-13] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Passing Yards.";
}
$headlab->configure(-text =>"\n\n       pa  pc  PY   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortpy
#//////////////


#/////
#sub  sortpc
#/////
sub sortpc
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

$bypc=1;
$order="by PC";

$statrot->delete(0, 'end');

if ($offselect==0)
{
@sdefarr = sort { (split ' ', $b )[-14] cmp  (split ' ', $a)[-14] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Pass Completions.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-14] cmp  (split ' ', $a)[-14] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Pass Completions.";
}
$headlab->configure(-text =>"\n\n       pa  PC  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortpc
#//////////////


#/////
#sub  sortpa
#/////
sub sortpa
{
#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;
$bypa=1;
$order="by PA";
$statrot->delete(0, 'end');

if ($offselect==0) #defense
{
@sdefarr = sort { (split ' ', $b )[-15] cmp  (split ' ', $a)[-15] } @defarr;

foreach my $line (@sdefarr)
{
$statrot->insert('end', $line);
}
$message="Defense selected. Sorted by Pass Attempts.";
}

else  #offense
{
@soffarr = sort { (split ' ', $b )[-15] cmp  (split ' ', $a)[-15] } @offarr;

foreach my $line (@soffarr)
{
$statrot->insert('end', $line);
}
$message="Offense selected. Sorted by Pass Attempts.";
}
$headlab->configure(-text =>"\n\n       PA  pc  py   ptd  r   ry  rtd in sck fm  rty  pen  peny  pavg  ravg");
}
#//////////////
#end sub sortpa
#//////////////


#//////////
#sub saving
#//////////
sub saving
{

my (@savarr, $filename, @savedvar);


 @savarr=$statrot->get(0, 'end');

# my $savedvar=$statrot->get('1.0', 'end');

if ($offselect ==0)
{
	$savedvar[0] = "Defense $order";
}
elsif ($offselect ==1)
{
	$savedvar[0] = "Offense $order";
}


    
  $savedvar[1] = "            PA  PC  PY   PTD  R   RY  RTD In Sck Fm  RtY  Pen  PenY  PAvg  RAvg";

@savarr= push (@savedvar, @savarr);
@savarr=@savedvar;
       
     my $index=0;

        foreach my $savline (@savarr)
            {
                $savarr[$index] = "$savline\n";
                $index++;
			}

if ($byravg==1)
{
	$filename="stats-ravg.txt";
}
elsif ($bypavg==1)
{
	$filename="stats-pavg.txt";
}
elsif ($bypeny==1)
{
	$filename="stats-peny.txt";
}
elsif ($bypen==1)
{
	$filename="stats-pen.txt";
}
elsif ($byrty==1)
{
	$filename="stats-rty.txt";
}
elsif ($byfm==1)
{
	$filename="stats-fm.txt";
}
elsif ($bysck==1)
{
	$filename="stats-sck.txt";
}
elsif ($byin==1)
{
	$filename="stats-in.txt";
}
elsif ($byrtd==1)
{
	$filename="stats-rtd.txt";
}
elsif ($byry==1)
{
	$filename="stats-ry.txt";
}
elsif ($byr==1)
{
	$filename="stats-r.txt";
}
elsif ($byptd==1)
{
	$filename="stats-ptd.txt";
}
elsif ($bypy==1)
{
	$filename="stats-py.txt";
}
elsif ($bypc==1)
{
	$filename="stats-pc.txt";
}
elsif ($bypa==1)
{
	$filename="stats-pa.txt";
}
else
{
$message="Erst sortieren, dann speichern";
return 1;
}

if ($offselect==0)
 {
	 $filename= "d" . $filename;
 }
elsif ($offselect==1)
 {
	 $filename= "o" . $filename;
 }


my $printname = ">". $filename;

 open(SAVFILE, $printname) or print "Couldn't open $filename far saving\n";

print SAVFILE @savarr;
        $message="$filename gespeichert.";
        close SAVFILE;

#clear flags
$byravg=0;$bypavg=0;$byravg=0;$bypeny=0;$bypen=0;$byrty=0;$byfm=0;$bysck=0;$byin=0;$byrtd=0;$byry=0;$byr=0;$byptd=0;$bypy=0;$bypc=0;$bypa=0;

}

#/////////////
# end sub saving
#////////////


#////////////
sub abouthelp
{
        if (!Exists( $ph2))
        {
         ($ph2) = $p3->Scrolled ('ROText',-scrollbars => 'ose', -height=>8)->pack;
          $ph2->insert('end', $abouthelp);
       }
        else
        {
                $ph2->delete('1.0', 'end');
                $ph2->insert('end', $abouthelp);
    }
}


#////////////
# end sub abouthelp
#//////////

sub bind_message 
{
	my ($widget, $msg) = @_;
	$widget->bind('<Enter>', [sub {$message = $_[1]; }, $msg]);
    $widget->bind('<Leave>', sub { $message = "";});
}





#////////////
sub findteam
{

my @savarr=$statrot->get(0, 'end');

#my	@savarr= split ("\n", $savedvar);
	my $index=0;

	foreach my $savline (@savarr)
	{

		if ($savline =~ m/$findteam/i)
		{
			$savline =~ s/ /_/g;
            $savarr[$index] = $savline;
#            print "yup.";
         my  $found=1;
        }
	



    	$savarr[$index] = "$savline"; 
		$index++;

    }



  $statrot->delete(0,'end');

	foreach my $savline (@savarr)
	{
    	$statrot->insert('end', $savline);
    }



	







}

#
#end sub findteam
# 







